minor bug fix
[distro-setup] / distro-begin
index 35c904a929d05693c03e73ef213fd6740843efa1..89a09babf4e1f78c6a9af33ed530985da90a0359 100755 (executable)
 # limitations under the License.
 
 # for setting up a new machine
-# usage: $0 [-r] HOSTNAME
+# usage: $0 [-r] [HOSTNAME]
+# HOSTNAME changes the machine's hostname
 
 # tips:
 # run any sudo command first so your pass is cached
 # set the scrollback to unlimited in case something goes wrong
 
 
+# send to registrar, glue records:
+# for iankelling.org:
+
+# ns1.iankelling.org 72.14.176.105
+# ns1.iankelling.org 2600:3c00::f03c:91ff:fe6d:baf8
+# ns2.iankelling.org 172.105.84.95
+# ns2.iankelling.org 2a01:7e01::f03c:91ff:feb5:baec
+
+# for zroe.org:
+
+# ns1.zroe.org 72.14.176.105
+# ns1.zroe.org 2600:3c00::f03c:91ff:fe6d:baf8
+# ns2.zroe.org 172.105.84.95
+# ns2.zroe.org 2a01:7e01::f03c:91ff:feb5:baec
+#
+
+
+
 ####### begin setup environment #######
 
 
@@ -32,16 +51,15 @@ sudo bash -c 'source /a/c/.bashrc && source /a/exe/ssh-emacs-setup'
 interactive=true  # set this to false to force set -x
 [[ $- == *i* ]] || interactive=false
 if ! $interactive; then
-    set -x
-    set -e -o pipefail
+  set -x
 fi
-set -E
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
-for x in /a/bin/errhandle/*-function; do
-    source $x
-done
-set +e
-$interactive || errcatch
+source /a/bin/errhandle/err
+
+_errcatch_cleanup() {
+  echo 1 >~/.local/distro-begin
+}
+
+source /a/bin/distro-functions/src/package-manager-abstractions
 
 ### setup logging
 exec &> >(sudo tee -a /var/log/distro-begin)
@@ -50,44 +68,51 @@ echo "$0: $(date): starting now)"
 
 ### sanity checking
 if [[ $EUID == 0 ]]; then
-    if getent passwd iank || getent passwd ian ; then
-        echo "$0: error: running as root. unprivileged user exists. use it."
-        exit 1
-    else
-        echo "$0: warning: running as root. I will setup users then exit"
-    fi
+  if getent passwd iank || getent passwd ian ; then
+    echo "$0: error: running as root. unprivileged user exists. use it."
+    exit 1
+  else
+    echo "$0: warning: running as root. I will setup users then exit"
+  fi
 fi
 
 
 ### arg parsing
 recompile=false
+emacs=true
 while [[ $1 == -* ]]; do
-    case $1 in
-        -r) recompile=true; shift ;;
-    esac
+  case $1 in
+    -r) recompile=true; shift ;;
+    -e) emacs=false; shift ;;
+  esac
 done
 if [[ $1 ]]; then
-    export HOSTNAME=$1
+  export HOSTNAME=$1
 fi
 
 
 ##### variables/env setup
-script_dir="$(readlink -f "$BASH_SOURCE")"; script_dir=${script_dir%/*}
+script_dir="$(readlink -f "${BASH_SOURCE[@]}")"; script_dir=${script_dir%/*}
+# shellcheck source=./pkgs
 source $script_dir/pkgs
 set +x
 source /a/bin/distro-functions/src/identify-distros
 $interactive || set -x
-for f in iank-dev htpc kd x2 frodo tp li lj demohost kw fz; do
-    eval "$f() { [[ $HOSTNAME == $f ]]; }"
+for f in kd x2 x3 frodo tp li l2 demohost kw; do
+  eval "$f() { [[ $HOSTNAME == $f ]]; }"
 done
-has_p() { ! linode; } # when tp is tracis, then not tp either
-has_x() { ! linode; }
-linode() { lj || li; }
+codename=$(debian-codename)
+has_wayland() { has_monitor && [[ $codename == buster ]]; }
+has_x() { has_monitor && [[ $codename != buster ]]; }
+has_monitor() { ! linode ; }
+linode() { l2 || li; }
+# linode actually has btrfs now, but we dont do anything with it.
 has_btrfs() { ! linode; }
-home_network() { ! linode; }
-encrypted() { has_p; }
+home_network() { ! linode && ! kw; }
+has_p() { ! linode; }
+encrypted() { true; }
 shopt -s extglob
-export GLOBIGNORE=*/.:*/..
+export GLOBIGNORE="*/.:*/.."
 umask 022
 PATH="/a/exe:$PATH"
 sed="sed --follow-symlinks"
@@ -99,11 +124,13 @@ sed="sed --follow-symlinks"
 
 ##### begin setup encryption scripts ######
 if encrypted; then
-    # I tried making a service which was dependent on reboot.target,
-    # but it happened too late in the shutdown process.
-    sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
+  # I tried making a service which was dependent on reboot.target,
+  # but it happened too late in the shutdown process.
+  sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
 [Unit]
 Description=Turn on automatic decryption of drives on boot
+# This is triggered by reboot and when keyscriptoff stops.
+
 # tried using graphical.target, but it made my display manager restart before rebooting.
 # generally, I don't think targets order shutdown like they do startup.
 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
@@ -122,12 +149,10 @@ ExecStop=/a/exe/keyscript-on
 [Install]
 WantedBy=keyscriptoff.service
 EOF
-    sudo systemctl daemon-reload # needed if the file was already there
-    sudo systemctl stop keyscripton.service
-    #    sudo systemctl start keyscripton.service
-    sudo systemctl enable keyscripton.service
+  sudo systemctl daemon-reload # needed if the file was already there
+  sudo systemctl enable keyscripton.service
 
-    sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
+  sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
 [Unit]
 Description=Turn off automatic decryption of drives on boot
 
@@ -138,9 +163,28 @@ ExecStart=/a/exe/keyscript-off
 [Install]
 WantedBy=multi-user.target
 EOF
-    sudo systemctl daemon-reload # needed if the file was already there
-    sudo systemctl enable keyscriptoff.service
-    sudo systemctl start keyscriptoff.service
+  sudo systemctl daemon-reload # needed if the file was already there
+  sudo systemctl enable keyscriptoff.service
+  sudo systemctl start keyscriptoff.service
+
+  pi rsync
+
+  # from /usr/share/doc/dropbear-initramfs/README.initramfs.gz
+  tmp=$(mktemp)
+  while read -r m _; do /sbin/modinfo -F filename "$m"; done </proc/modules | \
+    sed -nr "s@^/lib/modules/$(uname -r)/kernel/drivers/net(/.*)?/([^/]+)\.ko\$@\2@p" \
+    | sudo dd of=$tmp
+  if ! diff -q /etc/initramfs-tools/modules $tmp &>/dev/null; then
+    sudo dd if=$tmp of=/etc/initramfs-tools/modules
+    sudo /usr/sbin/update-initramfs -u -k all
+  fi
+  # initram auth keys get setup with rootsshsync
+  $script_dir/rootsshsync
+  # then for remote unlock, ssh and do this once per crypt disk:
+  # echo -n PASS >/lib/cryptsetup/passfifo
+  # or for buster+
+  # cryptroot-unlock
+
 fi
 ##### end setup encryption scripts ######
 
@@ -150,81 +194,79 @@ fi
 
 # todo, it would be nice to cut down on some of the output
 
-##### fedora prereq/fundamental settings
-if isfedora; then
-    # comment out line disallowing calling sudo in scripts
-    sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
-    # turn on magic sysrq commands
-    echo 1 > sudo dd of=/proc/sys/kernel/sysrq
-    echo "kernel.sysrq = 1" > /etc/sysctl.d/90-sysrq.conf
-    # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
-    # and you have no idea why.
-    sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
-    selinuxenabled && sudo setenforce 0
-fi
-
 
 #### rerun my fai-time scripts
 # already ran for pxe installs, but used for vps & updates
 distro=$(distro-name)
 case $distro in
-    ubuntu|debian|trisquel)
-        sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-iank"
-        ;;
-    *)
-        sudo bash -c ". /a/bin/fai/fai-wrapper &&
+  ubuntu|debian|trisquel)
+    sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-iank"
+    ;;
+  *)
+    sudo bash -c ". /a/bin/fai/fai-wrapper &&
 /a/bin/fai/fai/config/distro-install-common/end"
-        ;;
+    ;;
 esac
 
 ###### setup hostname
-sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
-echo "127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME" | sudo tee -a /etc/hosts
+if [[ $HOSTNAME != $(cat /etc/hostname) ]]; then
+  echo $HOSTNAME > /etc/hostname
+  hostname -F /etc/hostname
+fi
+sudo sed -i --follow-symlinks -f - /etc/hosts <<EOF
+\$a 127.0.1.1 $HOSTNAME.b8.nz $HOSTNAME
+/^127\.0\.1\.1/d
+EOF
 
 
 ##### exit first stage if running as root
 if [[ $EUID == 0 ]]; then
-    echo "$0: running as root. exiting now that users are setup"
-    exit 0
+  echo "$0: running as root. exiting now that users are setup"
+  exit 0
 fi
 
 
 #### setup bash for root
-for x in /a/c/{.bashrc,brc,.bash_profile,.profile,.inputrc,path_add_function}; do
-    sudo -i <<EOF
+for x in /a/c/{.bashrc,brc,brc2,.bash_profile,.profile,.inputrc,path_add_function}; do
+  sudo -i <<EOF
 PATH="/a/exe:$PATH"
 lnf $x /root
 EOF
 done
 
 ###### do conflink
-# li needs the bind group before conflink
-if [[ $HOSTNAME == li ]]; then
-    getent group bind &>/dev/null || sudo groupadd -r bind
+# linode needs bind group before conflink
+if $linode; then
+  pi-nostart bind9
 fi
 # this needs to be before installing pacserve so we have gpg conf.
 conflink
 
 ###### bash environment setup
 set +x
-errallow
+err-allow
 source /etc/profile.d/environment.sh
+# shellcheck source=./.bashrc
 source ~/.bashrc
-$interactive || errcatch
+err-catch
 $interactive || set -x
 
 
 #### setup passwordless sudo
-tu /etc/sudoers <<EOF
-$USER  ALL=(ALL)  NOPASSWD: ALL
-Defaults  env_keep += SUDOD
+
+# always_set_home
 # makes ubuntu be like debian
 # https://unix.stackexchange.com/a/91572
-Defaults always_set_home
-# default setting is to have  minimum umask of 0022
+
+# umask: default setting is to have  minimum umask of 0022
 # This lets us have user-specific umasks which are more permissive.
 # I did this for transmission and set it's umask gecos on install,
 # see there for more info.
+
+tu /etc/sudoers <<EOF
+$USER  ALL=(ALL)  NOPASSWD: ALL
+Defaults  env_keep += SUDOD
+Defaults always_set_home
 Defaults !umask
 EOF
 
@@ -248,29 +290,29 @@ EOF
 
 ######  arch aur wrapper setup
 if isarch; then
-    #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
-    sudo pacman -S --noconfirm --needed base-devel jq
-    # pacaur seems to be the best, although it + cower has a few minor bugs,
-    # its design goals seem good, so, going for it.
-
-    aurpi() {
-        for p in "$@"; do
-            tempdir=$(mktemp -d)
-            pushd $tempdir
-            aurex "$p"
-            makepkg -sri --skippgpcheck --noconfirm
-            popd
-            rm -rf $tempdir
-        done
-    }
-    aurpi cower pacaur
-
-    pi pacserve
-
-    x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
-    sudo dd of=/etc/pacman.conf if=$x; rm $x
-    sudo systemctl enable pacserve.service
-    sudo systemctl start pacserve.service
+  #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
+  sudo pacman -S --noconfirm --needed base-devel jq
+  # pacaur seems to be the best, although it + cower has a few minor bugs,
+  # its design goals seem good, so, going for it.
+
+  aurpi() {
+    for p in "$@"; do
+      tempdir=$(mktemp -d)
+      pushd $tempdir
+      aurex "$p"
+      makepkg -sri --skippgpcheck --noconfirm
+      popd
+      rm -rf $tempdir
+    done
+  }
+  aurpi cower pacaur
+
+  pi pacserve
+
+  x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
+  sudo dd of=/etc/pacman.conf if=$x; rm $x
+  sudo systemctl enable pacserve.service
+  sudo systemctl start pacserve.service
 
 fi
 
@@ -279,115 +321,64 @@ pup
 
 
 ###### p1 packages install ######
-if isarch; then
-    # requirement for trash-cli.
-    # background: strange error if just installing trash-cli: "pyalpm requires python",
-    # so I see that it requires python2, and installing that manually fixes it.
-    # I didn\'t see this on earlier installation, main thing which changed was
-    # pacserve, so not sure if it\'s related.
-    pi python2
-fi
 pi ${p1[@]}
 
 
 ######## fix evbug bug ######
 case $distro in
-    trisquel|ubuntu)
-        # noticed in flidas.
-        #https://bugs.launchpad.net/ubuntu/+source/module-init-tools/+bug/240553
-        #https://wiki.debian.org/KernelModuleBlacklisting
-        #common advice when searching is to use /etc/modprobe.d/blacklist.conf,
-        #but that file won't work and will get automatically reverted
-        sudo rmmod evbug ||: # might not be loaded yet
-        file=/etc/modprobe.d/evbug.conf
-        line="blacklist evbug"
-        if ! grep -xFq "$line" $file; then
-            sudo dd of=$file 2>/dev/null <<<"$line"
-            sudo depmod -a
-            sudo update-initramfs -u
-        fi
-        ;;
+  trisquel|ubuntu)
+    # noticed in flidas.
+    #https://bugs.launchpad.net/ubuntu/+source/module-init-tools/+bug/240553
+    #https://wiki.debian.org/KernelModuleBlacklisting
+    #common advice when searching is to use /etc/modprobe.d/blacklist.conf,
+    #but that file won't work and will get automatically reverted
+    sudo rmmod evbug ||: # might not be loaded yet
+    file=/etc/modprobe.d/evbug.conf
+    line="blacklist evbug"
+    if ! grep -xFq "$line" $file; then
+      sudo dd of=$file 2>/dev/null <<<"$line"
+      sudo depmod -a
+      sudo update-initramfs -u
+    fi
+    ;;
 esac
 
 
 ###### link files
 # convenient to just do all file linking in one place
-s lnf -T /a/bin /b
-s lnf -T /nocow/t /t
+s /a/exe/lnf -T /a/bin /b
+s /a/exe/lnf -T /nocow/t /t
 if has_p; then
-    lnf -T /p/News ~/News
+  lnf -T /p/News ~/News
 fi
-s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
+s /a/exe/lnf /q/root/.editor-backups /q/root/.undo-tree-history \
   /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
-rootsshsync
-s lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
-if has_p; then
-    # for dovecot
-    lnf -T /i/k/mboxes ~/mail
-fi
+/a/bin/ds/install-my-scripts # needed for rootsshsync cronjob
+s /a/exe/lnf /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
 
 
 
 
-##### install xinput
-if has_x; then
-    case $(distro-name) in
-        trisquel|ubuntu|debian)
-            pi xinput
-            ;;
-        fedora)
-            pi xinput_calibrator
-            ;;
-        arch)
-            pi xorg-xinput
-            ;;
-    esac
-
-    #### install redshift
-    case $(distro-name) in
-        trisquel|ubuntu|debian)
-            # recommends gets us geoclue (for darkening automatically at night i assume),
-            # which recommends modemmanager, which is annoying to fix for the model01 keyboard.
-            pi --no-install-recommends gtk-redshift
-            ;;&
-        fedora)
-            pi redshift-gtk
-            ;;&
-        arch)
-            pi redshift
-            ;;&
-    esac
-fi
-
 
 #### arch specific early packages
 case $(distro-name) in
-    arch)
-        # pkgfile is like apt-cache
-        pi pkgfile
-        s pkgfile --update
-        ;;
-esac
-
-#### fedora specific packages
-case $(distro-name) in
-    fedora)
-        # todo, this could probably come later
-        p -y groupinstall development-tools c-development books admin-tools
-        pi man-pages
-        ;;
-    # other distros unknown
+  arch)
+    # pkgfile is like apt-cache
+    pi pkgfile
+    s pkgfile --update
+    ;;
 esac
 
 #### enable trim
 # enable trim for volume delete, other rare commands
 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
 if encrypted; then
-    if isdeb; then
-        sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
-    fi
-    # does weekly trim
-    sudo systemctl enable fstrim.timer
+  # flidas or so, these units arent built-in
+  if isdeb && ! systemctl list-unit-files | grep ^fstrim.timer &>/dev/null ; then
+    sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
+  fi
+  # does weekly trim
+  sudo systemctl enable fstrim.timer
 fi
 
 ##### make extra dirs
@@ -396,44 +387,42 @@ s mkdir -p "${dirs[@]}"
 s chown $USER:$USER  "${dirs[@]}"
 
 ###### setup /i
-tu /etc/fstab <<'EOF'
+if home_network; then
+  tu /etc/fstab <<'EOF'
 /i/w  /w  none  bind,noauto  0 0
 /i/k  /k  none  bind,noauto  0 0
 EOF
-if ! mountpoint /kr; then
+  if ! mountpoint /kr; then
     s mkdir -p /kr
-    s chown $USER:traci /kr
-fi
-if home_network; then
-    if [[ $HOSTNAME == frodo ]]; then
-        tu /etc/fstab <<'EOF'
+    s chown $USER:user2 /kr
+  fi
+  if [[ $HOSTNAME == frodo ]]; then
+    tu /etc/fstab <<'EOF'
 /k  /kr  none  bind,noauto  0 0
 EOF
-    else
-        tu /etc/fstab <<'EOF'
+  else
+    tu /etc/fstab <<'EOF'
 frodo:/k  /kr  nfs  noauto  0 0
 EOF
-    fi
-fi
-s mkdir -p /q /i/{w,k}
-for dir in /{i,w,k}; do
+  fi
+  s mkdir -p /q /i/{w,k}
+  for dir in /{i,w,k}; do
     if mountpoint $dir; then continue; fi # already mounted
     s mkdir -p $dir
     s chown $USER:$USER $dir
-done
-# not needed for all hosts, but rather just keep it uniform
-s mkdir -p /mnt/iroot
-# debian auto mounting of multi-disk encrypted btrfs is busted.  It is
-# in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
-# based on 3 of those, it creates .device units for /dev/mapper/dev...
-# then waits endlessly for them on bootup, after the /dev/mapper disks
-# have already been created and exist. todo: create a simple repro
-# for this in a vm and report it upstream.
-if has_btrfs || home_network; then
-    pi nfs-common
-    s dd of=/root/imount <<'EOF'
+  done
+  # not needed for all hosts, but rather just keep it uniform
+  s mkdir -p /mnt/iroot
+  # debian auto mounting of multi-disk encrypted btrfs is busted.  It is
+  # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
+  # based on 3 of those, it creates .device units for /dev/mapper/dev...
+  # then waits endlessly for them on bootup, after the /dev/mapper disks
+  # have already been created and exist. todo: create a simple repro
+  # for this in a vm and report it upstream.
+  pi nfs-common
+  s dd of=/root/imount <<'EOF'
 #!/bin/bash
-[[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+[[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 for dir in /i /mnt/iroot /k /kr /w; do
@@ -447,9 +436,8 @@ for dir in /i /mnt/iroot /k /kr /w; do
     fi
 done
 EOF
-    s chmod +x /root/imount
-
-    s dd of=/etc/systemd/system/imount.service <<EOF
+  s chmod +x /root/imount
+  s dd of=/etc/systemd/system/imount.service <<EOF
 [Unit]
 Description=Mount /i and related mountpoints
 Before=syncthing@$USER.service
@@ -466,173 +454,160 @@ RequiredBy=syncthing@$USER.service
 # at some time after network.target
 WantedBy=multi-user.target
 EOF
-    sudo systemctl daemon-reload # needed if the file was already there
-    sudo systemctl enable imount.service
-    sudo systemctl start imount.service
+  sudo systemctl daemon-reload # needed if the file was already there
+  sudo systemctl enable imount.service
+  sudo systemctl start imount.service
 fi
+###### end setup /i
 
 ##### setup /nocow.
 # a nocow dir that is common to multiple distros installed on the same system
 dir=/nocow
 if has_btrfs; then
-    if ! mountpoint $dir; then
-        subvol=/mnt/root/nocow
-        if [[ ! -e $subvol ]]; then
-            s btrfs subvolume create $subvol
-            s chown root:1000 $subvol
-            s chattr +C $subvol
-        fi
+  if ! mountpoint $dir; then
+    subvol=/mnt/root/nocow
+    if [[ ! -e $subvol ]]; then
+      s btrfs subvolume create $subvol
+      s chown root:1000 $subvol
+      s chattr +C $subvol
+    fi
 
-        first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
-        tu /etc/fstab <<EOF
+    first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
+    tu /etc/fstab <<EOF
 $first_root_crypt  /nocow  btrfs  noatime,subvol=nocow  0 0
 EOF
-        s mkdir -p $dir
-        s chown $USER:$USER $dir
-        s mount $dir
-    fi
+    s mkdir -p $dir
+    s chown $USER:$USER $dir
+    s mount $dir
+  fi
 else
-    sudo mkdir -p $dir
-fi
-
-
-###### fix mouse on jessie
-#  it comes with stretch and arch, but not jessie.
-# propogate /etc/udev/hwdb.d
-if which systemd-hwdb; then
-    s systemd-hwdb update
-    ser restart systemd-udev-trigger
+  sudo mkdir -p $dir
 fi
 
 
 ##### setup email
-if isdeb; then
-    mail-setup exim4
-else
-    # todo: probably broken
-    mail-setup postfix
-fi
+mail-setup
 
 #### ubuntu nicety
 if isubuntu; then
-    # disable crash report annoying dialogs.
-    s dd of=/etc/default/apport <<<'enabled=0'
+  # disable crash report annoying dialogs.
+  s dd of=/etc/default/apport <<<'enabled=0'
 fi
 
-###### setup time zone
-# fai sets this an old way that doesn't work for stretch.
-# no harm in setting it universally here.
-# using debconf-set-selection, the area gets reset to ETC
-# on my linode test machine after doing a dpkg-reconfigure, or a reinstall,
-# so we are using expect :(
-# I got a random error when running this, so I added a sleep
-# rather than trying to write a whole detect and wait loop.
-# E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
-# E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
-sleep 1
-# todo: this is not idempotent, it fails when running twice, due to prepopulated values.
-# check into unsetting them using debconf-set-selection.
-s apt-get -y install --no-install-recommends expect
-s expect <<EOF ||:
-set force_conservative 0
-spawn dpkg-reconfigure tzdata -freadline
-expect -nocase timeout {exit 1} "Geographic area:"
-send "\02512\r"
-expect -nocase timeout {exit 1} "Time zone:"
-send "\0255\r"
-expect eof
-exit
-EOF
 
 
-##### install  emacs
-if has_x; then
-    if isarch; then
-        # emacs git build was broken last time i checked,
-        x=$(mktemp -d)
-        pushd $x
-        aurex emacs-git
-        makepkg -si --noconfirm
-        popd
-        rm -rf $x
-        pi hunspell hunspell-en
-    else
-        if $recompile; then
-            /a/bin/buildscripts/emacs
-        else
-            /a/bin/buildscripts/emacs --no-r || /a/bin/buildscripts/emacs
-        fi
-    fi
-fi
-
 ##### install laptop hardware packages
-if tp || x2; then
-    case $distro in
-        debian)
-            pi task-laptop
-            ;;
-        ubuntu|trisquel)
-            # the exact packages that task-laptop would install, since ubuntu
-            # doesn\'t have this virtual in practice package.
-            pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
-            ;;
-        # todo: other distros unknown
-    esac
+if tp || x2 || x3; then
+  case $distro in
+    debian)
+      pi task-laptop
+      ;;
+    ubuntu|trisquel)
+      # the exact packages that task-laptop would install, since ubuntu
+      # doesn\'t have this virtual in practice package.
+      pi avahi-autoipd bluetooth powertop iw wireless-tools wpasupplicant
+      ;;
+    # todo: other distros unknown
+  esac
 fi
 
-
-##### install xmonad
 if has_x; then
-    pi ${p2[@]}
-    # note: on older ubuntu I used cabal xmonad + xfce, using cabal versin
-    # see /w/archive/programming/xmonad-cabal.sh
-    if isarch; then
-        # xorg-xmessage for displaying error messages.
-        # optional dependency in arch, standard elsewhere.
-        pi xorg-server xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
-    else
-        pi suckless-tools
-    fi
-fi
-
-
-##### setup X autostart
-if has_x; then
-    if isarch; then
-        # https://wiki.archlinux.org/index.php/Xinitrc
-        for homedir in /home/*; do
-            cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
-            $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
-            tee -a $homedir/.xinitrc <<'EOF'
+  ###### install X
+  pi i3
+  if isarch; then
+    # xorg-xmessage for displaying error messages.
+    # optional dependency in arch, standard elsewhere.
+    pi xorg-server xorg-xmessage xorg-xsetroot xorg-xinit
+  fi
+
+  ##### install xinput
+  case $(distro-name) in
+    trisquel|ubuntu|debian)
+      pi xinput
+      ;;
+    arch)
+      pi xorg-xinput
+      ;;
+  esac
+
+  #### install redshift
+  case $(distro-name) in
+    trisquel|ubuntu|debian)
+      # recommends gets us geoclue (for darkening automatically at night i assume),
+      # which recommends modemmanager, which is annoying to fix for the model01 keyboard.
+      pi --no-install-recommends gtk-redshift
+      ;;&
+    arch)
+      pi redshift
+      ;;&
+  esac
+
+  ##### setup X autostart
+  if isarch; then
+    # https://wiki.archlinux.org/index.php/Xinitrc
+    for homedir in /home/*; do
+      cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
+      # shellcheck disable=SC2016
+      $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
+      tee -a $homedir/.xinitrc <<'EOF'
 /a/bin/desktop-20-autostart.sh
 xsetroot -cursor_name left_ptr
 exec xmonad
 EOF
-        done
-        else
-        # todo, figure this out for arch if we ever try out gnome.
-        # install for multiple display managers in case we use one
-        if isdeb; then
-            dir=/etc/gdm3
-        elif isfedora; then
-            # fedora didn\'t have the 3.
-            dir=/etc/gdm
-        fi
-        s mkdir -p $dir/PostLogin
-        s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
-        s mkdir /etc/lightdm/lightdm.conf.d
-        s dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
+    done
+  else
+    # todo, figure this out for arch if we ever try out gnome.
+    # install for multiple display managers in case we use one
+    dir=/etc/gdm3
+    s mkdir -p $dir/PostLogin
+    s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
+    s mkdir /etc/lightdm/lightdm.conf.d
+    s dd of=/etc/lightdm/lightdm.conf.d/12-iank.conf <<'EOF'
 [SeatDefaults]
 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
 EOF
-    fi
+  fi
+
 fi
 
+### install and configure wayland
+if has_wayland; then
+  pi sway xwayland
+  # originally used xkbcomp, documented in input-setup.sh, this doesnt
+  # work under wayland, but its still useful for creating the config,
+  # then modifying the system files.
+  s sed -i.orig '/key *<KPMU> *{/,/}/s/KP_Multiply/underscore/g' /usr/share/X11/xkb/symbols/keypad
+fi
+
+##### basic graphical packages
+if has_monitor; then
+  pi konsole suckless-tools
+fi
 
-#### refix interactive ssh terminal
-# the first pup command can kill off our /etc/ mod, so rerun this
-/a/exe/ssh-emacs-setup
+
+##### install  emacs
+if $emacs; then
+  if isarch; then
+    # emacs git build was broken last time i checked,
+    x=$(mktemp -d)
+    pushd $x
+    aurex emacs-git
+    makepkg -si --noconfirm
+    popd
+    rm -rf $x
+    pi hunspell hunspell-en
+  else
+    if $recompile; then
+      /a/bin/buildscripts/emacs
+    else
+      /a/bin/buildscripts/emacs --no-r
+    fi
+  fi
+  # the first pup command can kill off our /etc/ mod, so rerun this
+  /a/exe/ssh-emacs-setup
+fi
 
 
+echo 0 >~/.local/distro-begin
 echo "$0: $(date): ending now"
 exit 0